#include "mex.h"
#include "matrix.h"

void resample_v(unsigned int document, double* order)
{
	unsigned int j, k;
	unsigned int vIdx;
	unsigned int newV;
	unsigned int numSents = g_numSents[document];

	memcpy(g_proposedV, g_v + index2d(0, g_K - 1, document), (g_K - 1) * sizeof(unsigned int));
	memcpy(g_proposedTopics, g_t + index2d(0, g_maxNumSents, document), numSents * sizeof(unsigned int));

	/* For each V position */
	for (j = 0; j < g_K - 1; ++j)
	{
		vIdx = round(order[j] - 1.0);
		g_nvs[vIdx] -= g_v[index2d(vIdx, g_K - 1, document)];

		/* Consider each possible new value of V, which depends on position of course */
		for (k = 0; k < g_K - vIdx; ++k)
		{
			g_proposedV[vIdx] = k;
			setGlobalPermutation(g_proposedV);
			qsort(g_proposedTopics, numSents, sizeof(unsigned int), permutationCompare);

			/* Prior + likelihood, in log space of course */
			g_vProb[k] = sentenceProb(document, 0, numSents, g_proposedTopics, g_documentWords);
			if (g_model == MALLOWS_LDA)
			{
				g_vProb[k] += -g_rho[vIdx] * (double)k;
			}
		}

		/* Sample new value, assign back to both true and proposal V's */
		newV = sampleNormalized(g_vProb, g_K - vIdx, g_unifrand[g_randIdx++]);
		g_v[index2d(vIdx, g_K - 1, document)] = newV;
		g_proposedV[vIdx] = newV;
		g_nvs[vIdx] += newV;
	}
}