function [output, outputtail] = run_inference (datapath, ...
												outputpath, ...
												runname, ...
												model, ...
												K, ...
												lmprior, ...
												tauprior, ...
												sigmaprior, ...
												rhoprior, ...
												nuprior, ...
												iterations, ...
												dosave)


keep = 2;

%% ----------------------------------------------------------------
% Metadata
fprintf ('%s\n', strcat (datapath, '/meta'));
numSents = csvread (strcat (datapath, '/meta'));
[junk,vocab] = textread (strcat (datapath, '/vocab'),'%d,%[^\n]');
vocabSize = size (vocab, 1);


%% ----------------------------------------------------------------
% Document data
numDocs = size (numSents, 1);
documents = repmat (struct ('count', sparse (vocabSize, max (numSents))), numDocs, 1);
fid = fopen (strcat (datapath, '/data'));
for i = 1:numDocs
    documents (i).count = sparse (vocabSize, numSents (i));
    % Read appropriate number of sentences
    for j = 1:numSents (i)
        raw = textscan (fid,'%d:%d,');
        documents (i).count = documents (i).count + ...
							  sparse (double (raw{1} + 1), ...
							  		  j, ...
									  double (raw{2}), ...
									  vocabSize, ...
									  numSents (i));
    end
end
fclose (fid);


%% ----------------------------------------------------------------
% Infer model paramters
filename = strcat (outputpath, runname);
[output, outputtail] = inference (documents, ...
                                  numSents, ...
								  model, ...
								  K, ...
								  lmprior, ...
								  tauprior, ...
								  sigmaprior, ...
								  rhoprior, ...
								  nuprior, ...
								  keep, ...
								  iterations, ...
								  dosave, ...
								  filename);

