function [rho] = sample_rho(totalV, numDocs, nminusj, v_0, nu_0, lastRho, burnin)

    function prob = logposterior(rho)
        if rho > 0
            prob = -rho * (totalV + v_0 * nu_0) - (nu_0 + numDocs) * (log1p(-exp(-nminusj * rho)) - log1p(-exp(-rho)));
        else
            prob = -Inf;
        end
    end

rho = slicesample(lastRho, 1, 'logpdf', @logposterior, 'width', 5, 'burnin', burnin);

end